--- CVS/cperl-mode.el	2003-02-04 14:24:34.000000000 +0100
+++ pfeiffer/cperl-mode.el	2003-02-11 23:00:28.000000000 +0100
@@ -3095,100 +3078,99 @@
 		cperl-syntax-state nil
 		cperl-syntax-done-to min))
   (or max (setq max (point-max)))
-  (let* (face head-face here-face b e bb tag qtag b1 e1 argument i c tail tb
-	      is-REx is-x-REx REx-comment-start REx-comment-end was-comment i2
-	      (cperl-pod-here-fontify (eval cperl-pod-here-fontify)) go tmpend
-	      (case-fold-search nil) (inhibit-read-only t) (buffer-undo-list t)
-	      (modified (buffer-modified-p))
-	      (after-change-functions nil)
-	      (use-syntax-state (and cperl-syntax-state
-				     (>= min (car cperl-syntax-state))))
-	      (state-point (if use-syntax-state
-			       (car cperl-syntax-state)
-			     (point-min)))
-	      (state (if use-syntax-state
-			 (cdr cperl-syntax-state)))
-	      ;; (st-l '(nil)) (err-l '(nil)) ; Would overwrite - propagates from a function call to a function call!
-	      (st-l (list nil)) (err-l (list nil))
-	      ;; Somehow font-lock may be not loaded yet...
-	      (font-lock-string-face (if (boundp 'font-lock-string-face)
-					 font-lock-string-face
-				       'font-lock-string-face))
-	      (font-lock-constant-face (if (boundp 'font-lock-constant-face)
-					 font-lock-constant-face
-				       'font-lock-constant-face))
-	      (font-lock-function-name-face
-	       (if (boundp 'font-lock-function-name-face)
-		   font-lock-function-name-face
-		 'font-lock-function-name-face))
-	      (font-lock-comment-face
-	       (if (boundp 'font-lock-comment-face)
-		   font-lock-comment-face
-		 'font-lock-comment-face))
-	      (cperl-nonoverridable-face
-	       (if (boundp 'cperl-nonoverridable-face)
-		   cperl-nonoverridable-face
-		 'cperl-nonoverridable-face))
-	      (stop-point (if ignore-max
-			      (point-max)
-			    max))
-	      (search
+  (let* ((cperl-pod-here-fontify (eval cperl-pod-here-fontify)) go tmpend
+	 face head-face here-face b e bb tag qtag b1 e1 argument i c tail tb
+	 is-REx is-x-REx REx-comment-start REx-comment-end was-comment i2
+	 (case-fold-search nil) (inhibit-read-only t) (buffer-undo-list t)
+	 (modified (buffer-modified-p))
+	 (after-change-functions nil)
+	 (use-syntax-state (and cperl-syntax-state
+				(>= min (car cperl-syntax-state))))
+	 (state-point (if use-syntax-state
+			  (car cperl-syntax-state)
+			(point-min)))
+	 (state (if use-syntax-state
+		    (cdr cperl-syntax-state)))
+	 ;; (st-l '(nil)) (err-l '(nil)) ; Would overwrite - propagates from a function call to a function call!
+	 (st-l (list nil)) (err-l (list nil))
+	 ;; Somehow font-lock may be not loaded yet...
+	 (font-lock-string-face (if (boundp 'font-lock-string-face)
+				    font-lock-string-face
+				  'font-lock-string-face))
+	 (font-lock-constant-face (if (boundp 'font-lock-constant-face)
+				      font-lock-constant-face
+				    'font-lock-constant-face))
+	 (font-lock-function-name-face
+	  (if (boundp 'font-lock-function-name-face)
+	      font-lock-function-name-face
+	    'font-lock-function-name-face))
+	 (font-lock-comment-face
+	  (if (boundp 'font-lock-comment-face)
+	      font-lock-comment-face
+	    'font-lock-comment-face))
+	 (cperl-nonoverridable-face
+	  (if (boundp 'cperl-nonoverridable-face)
+	      cperl-nonoverridable-face
+	    'cperl-nonoverridable-face))
+	 (stop-point (if ignore-max
+			 (point-max)
+		       max))
+	 (search
+	  (concat
+	   "\\(\\`\n?\\|^\n\\)="
+	   "\\|"
+	   ;; One extra () before this:
+	   "<<"
+	   "\\("			; 1 + 1
+	   ;; First variant "BLAH" or just ``.
+	   "[ \t]*"			; Yes, whitespace is allowed!
+	   "\\([\"'`]\\)"		; 2 + 1 = 3
+	   "\\([^\"'`\n]*\\)"		; 3 + 1
+	   "\\3"
+	   "\\|"
+	   ;; Second variant: Identifier or \ID or empty
+	   "\\\\?\\(\\([a-zA-Z_][a-zA-Z_0-9]*\\)?\\)" ; 4 + 1, 5 + 1
+	   ;; Do not have <<= or << 30 or <<30 or << $blah.
+	   ;; "\\([^= \t0-9$@%&]\\|[ \t]+[^ \t\n0-9$@%&]\\)" ; 6 + 1
+	   "\\(\\)"		; To preserve count of pars :-( 6 + 1
+	   "\\)"
+	   "\\|"
+	   ;; 1+6 extra () before this:
+	   "^[ \t]*\\(format\\)[ \t]*\\([a-zA-Z0-9_]+\\)?[ \t]*=[ \t]*$"
+	   (if cperl-use-syntax-table-text-property
 	       (concat
-		"\\(\\`\n?\\|^\n\\)="
 		"\\|"
-		;; One extra () before this:
-		"<<"
-		  "\\("			; 1 + 1
-		  ;; First variant "BLAH" or just ``.
-		     "[ \t]*"		; Yes, whitespace is allowed!
-		     "\\([\"'`]\\)"	; 2 + 1 = 3
-		     "\\([^\"'`\n]*\\)"	; 3 + 1
-		     "\\3"
-		  "\\|"
-		  ;; Second variant: Identifier or \ID or empty
-		    "\\\\?\\(\\([a-zA-Z_][a-zA-Z_0-9]*\\)?\\)" ; 4 + 1, 5 + 1
-		    ;; Do not have <<= or << 30 or <<30 or << $blah.
-		    ;; "\\([^= \t0-9$@%&]\\|[ \t]+[^ \t\n0-9$@%&]\\)" ; 6 + 1
-		    "\\(\\)"		; To preserve count of pars :-( 6 + 1
-		  "\\)"
+		;; 1+6+2=9 extra () before this:
+		"\\<\\(q[wxqr]?\\|[msy]\\|tr\\)\\>"
+		"\\|"
+		;; 1+6+2+1=10 extra () before this:
+		"\\([?/<]\\)"	; /blah/ or ?blah? or <file*glob>
+		"\\|"
+		;; 1+6+2+1+1=11 extra () before this:
+		"\\<sub\\>[ \t]*\\([a-zA-Z_:'0-9]+[ \t]*\\)?\\(([^()]*)\\)"
 		"\\|"
-		;; 1+6 extra () before this:
-		"^[ \t]*\\(format\\)[ \t]*\\([a-zA-Z0-9_]+\\)?[ \t]*=[ \t]*$"
-		(if cperl-use-syntax-table-text-property
-		    (concat
-		     "\\|"
-		     ;; 1+6+2=9 extra () before this:
-		     "\\<\\(q[wxqr]?\\|[msy]\\|tr\\)\\>"
-		     "\\|"
-		     ;; 1+6+2+1=10 extra () before this:
-		     "\\([?/<]\\)"	; /blah/ or ?blah? or <file*glob>
-		     "\\|"
-		     ;; 1+6+2+1+1=11 extra () before this:
-		     "\\<sub\\>[ \t]*\\([a-zA-Z_:'0-9]+[ \t]*\\)?\\(([^()]*)\\)"
-		     "\\|"
-		     ;; 1+6+2+1+1+2=13 extra () before this:
-		     "\\$\\(['{]\\)"
-		     "\\|"
-		     ;; 1+6+2+1+1+2+1=14 extra () before this:
-		     "\\(\\<sub[ \t\n\f]+\\|[&*$@%]\\)[a-zA-Z0-9_]*'"
-		     ;; 1+6+2+1+1+2+1+1=15 extra () before this:
-		     "\\|"
-		     "__\\(END\\|DATA\\)__"
-		     ;; 1+6+2+1+1+2+1+1+1=16 extra () before this:
-		     "\\|"
-		     "\\\\\\(['`\"]\\)"
-		     )
-		  ""))))
+		;; 1+6+2+1+1+2=13 extra () before this:
+		"\\$\\(['{]\\)"
+		"\\|"
+		;; 1+6+2+1+1+2+1=14 extra () before this:
+		"\\(\\<sub[ \t\n\f]+\\|[&*$@%]\\)[a-zA-Z0-9_]*'"
+		;; 1+6+2+1+1+2+1+1=15 extra () before this:
+		"\\|"
+		"__\\(END\\|DATA\\)__"
+		;; 1+6+2+1+1+2+1+1+1=16 extra () before this:
+		"\\|"
+		"\\\\\\(['`\"]\\)")
+	     ""))))
     (unwind-protect
 	(progn
 	  (save-excursion
 	    (or non-inter
 		(message "Scanning for \"hard\" Perl constructions..."))
 	    (and cperl-pod-here-fontify
-		;; We had evals here, do not know why...
-		(setq face cperl-pod-face
-		      head-face cperl-pod-head-face
-		      here-face cperl-here-face))
+		 ;; We had evals here, do not know why...
+		 (setq face cperl-pod-face
+		       head-face cperl-pod-head-face
+		       here-face cperl-here-face))
 	    (remove-text-properties min max
 				    '(syntax-type t in-pod t syntax-table t
 						  cperl-postpone t
@@ -3279,7 +3261,7 @@
 		  (cperl-commentify bb e nil)
 		  (goto-char e)
 		  (or (eq e (point-max))
-		      (forward-char -1)))) ; Prepare for immediate pod start.
+		      (forward-char -1)))) ; Prepare for immediate POD start.
 	       ;; Here document
 	       ;; We do only one here-per-line
                ;; ;; One extra () before this:
@@ -3333,11 +3315,11 @@
 			     (progn
 			       ;; Highlight the ending delimiter
 			       (cperl-postpone-fontification (match-beginning 0) (match-end 0)
-						  'face font-lock-constant-face)
+							     'face font-lock-constant-face)
 			       (cperl-put-do-not-fontify b (match-end 0) t)
 			       ;; Highlight the HERE-DOC
 			       (cperl-postpone-fontification b (match-beginning 0)
-						  'face here-face)))
+							     'face here-face)))
 			 (setq e1 (cperl-1+ (match-end 0)))
 			 (put-text-property b (match-beginning 0)
 					    'syntax-type 'here-doc)
@@ -3379,18 +3361,18 @@
 			(end-of-line)
 			;; Highlight the format line
 			(cperl-postpone-fontification b1 (point)
-					   'face font-lock-string-face)
+						      'face font-lock-string-face)
 			(cperl-commentify b1 (point) nil)
 			(cperl-put-do-not-fontify b1 (point) t))))
 		  ;; We do not search to max, since we may be called from
 		  ;; some hook of fontification, and max is random
 		  (re-search-forward "^[.;]$" stop-point 'toend))
 		(beginning-of-line)
-		(if (looking-at "^\\.$")	; ";" is not supported yet
+		(if (looking-at "^\\.$") ; ";" is not supported yet
 		    (progn
 		      ;; Highlight the ending delimiter
 		      (cperl-postpone-fontification (point) (+ (point) 2)
-					 'face font-lock-string-face)
+						    'face font-lock-string-face)
 		      (cperl-commentify (point) (+ (point) 2) nil)
 		      (cperl-put-do-not-fontify (point) (+ (point) 2) t))
 		  (message "End of format `%s' not found." name)
@@ -3418,7 +3400,7 @@
 			      (memq bb '(?\$ ?\@ ?\% ?\* ?\#)) ; $#y
 			      (and (eq bb ?-) (eq c ?s)) ; -s file test
 			      (and (eq bb ?\&)
-				   (not (eq (char-after  ; &&m/blah/
+				   (not (eq (char-after	; &&m/blah/
 					     (- (match-beginning b1) 2))
 					    ?\&))))
 			   ;; <file> or <$file>
@@ -3448,8 +3430,8 @@
 				      (and (eq (char-syntax (preceding-char)) ?w)
 					   (progn
 					     (forward-sexp -1)
-;; After these keywords `/' starts a RE.  One should add all the
-;; functions/builtins which expect an argument, but ...
+					     ;; After these keywords `/' starts a RE.  One should add all the
+					     ;; functions/builtins which expect an argument, but ...
 					     (if (eq (preceding-char) ?-)
 						 ;; -d ?foo? is a RE
 						 (looking-at "[a-zA-Z]\\>")
@@ -3596,13 +3578,13 @@
 			  (while
 			      (and (< (point) e)
 				   (re-search-forward
-				    (if is-x-REx
-					(if (eq (char-after b) ?\#)
+				    (if (eq (char-after b) ?\#)
+					(if is-x-REx
 					    "\\((\\?\\\\#\\)\\|\\(\\\\#\\)"
-					    "\\((\\?#\\)\\|\\(#\\)")
-					(if (eq (char-after b) ?\#)
-					    "\\((\\?\\\\#\\)"
-					  "\\((\\?#\\)"))
+					  "\\((\\?\\\\#\\)")
+				      (if is-x-REx
+					  "\\((\\?#\\)\\|\\(#\\)"
+					"\\((\\?#\\)"))
 				    (1- e) 'to-end))
 			    (goto-char (match-beginning 0))
 			    (setq REx-comment-start (point)
@@ -3744,13 +3726,12 @@
       (if (memq (setq pr (get-text-property (point) 'syntax-type))
 		'(pod here-doc here-doc-delim))
 	  (cperl-unwind-to-safe nil)
-      (if (or (looking-at "^[ \t]*\\(#\\|$\\)")
-	      (progn (cperl-to-comment-or-eol) (bolp)))
-	  nil	; Only comment, skip
-	;; Else
-	(skip-chars-backward " \t")
-	(if (< p (point)) (goto-char p))
-	  (setq stop t))))))
+      (or (looking-at "^[ \t]*\\(#\\|$\\)")
+	  (progn (cperl-to-comment-or-eol) (bolp))
+	  (progn
+	    (skip-chars-backward " \t")
+	    (if (< p (point)) (goto-char p))
+	    (setq stop t)))))))
 
 (defun cperl-after-block-p (lim)
   ;; We suppose that the preceding char is }.
@@ -3780,8 +3761,8 @@
 TEST is the expression to evaluate at the found position.  If absent,
 CHARS is a string that contains good characters to have before us (however,
 `}' is treated \"smartly\" if it is not in the list)."
-  (let (stop p
-	     (lim (or lim (point-min))))
+  (let ((lim (or lim (point-min)))
+	stop p)
     (save-excursion
       (while (and (not stop) (> (point) lim))
 	(skip-chars-backward " \t\n\f" lim)
@@ -3874,10 +3855,10 @@
   (interactive)
   (or end
       (setq end (point-max)))
-  (let (p pp ml have-brace ret
-	  (ee (save-excursion (end-of-line) (point)))
-	  (cperl-indent-region-fix-constructs
-	   (or cperl-indent-region-fix-constructs 1)))
+  (let ((ee (save-excursion (end-of-line) (point)))
+	(cperl-indent-region-fix-constructs
+	 (or cperl-indent-region-fix-constructs 1))
+	p pp ml have-brace ret)
     (save-excursion
       (beginning-of-line)
       (setq ret (point))
@@ -3887,165 +3868,165 @@
 	   (or (looking-at "[ \t]*\\(els\\(e\\|if\\)\\|continue\\|if\\|while\\|for\\(each\\)?\\|until\\)")
 	       (setq have-brace (save-excursion (search-forward "}" ee t)))))
 	  nil				; Do not need to do anything
-      ;; Looking at:
-      ;; }
-      ;; else
-      (if (and cperl-merge-trailing-else
-	       (looking-at
-		"[ \t]*}[ \t]*\n[ \t\n]*\\(els\\(e\\|if\\)\\|continue\\)\\>"))
-	  (progn
-	    (search-forward "}")
-	    (setq p (point))
-	    (skip-chars-forward " \t\n")
-	    (delete-region p (point))
-	    (insert (make-string cperl-indent-region-fix-constructs ?\ ))
-	    (beginning-of-line)))
-      ;; Looking at:
-      ;; }     else
-      (if (looking-at "[ \t]*}\\(\t*\\|[ \t][ \t]+\\)\\<\\(els\\(e\\|if\\)\\|continue\\)\\>")
-	  (progn
-	    (search-forward "}")
-	    (delete-horizontal-space)
-	    (insert (make-string cperl-indent-region-fix-constructs ?\ ))
-	    (beginning-of-line)))
-      ;; Looking at:
-      ;; else   {
-      (if (looking-at
-	   "[ \t]*}?[ \t]*\\<\\(\\els\\(e\\|if\\)\\|continue\\|unless\\|if\\|while\\|for\\(each\\)?\\|until\\)\\>\\(\t*\\|[ \t][ \t]+\\)[^ \t\n#]")
-	  (progn
-	    (forward-word 1)
-	    (delete-horizontal-space)
-	    (insert (make-string cperl-indent-region-fix-constructs ?\ ))
-	    (beginning-of-line)))
-      ;; Looking at:
-      ;; foreach my    $var
-      (if (looking-at
-	   "[ \t]*\\<for\\(each\\)?[ \t]+\\(my\\|local\\|our\\)\\(\t*\\|[ \t][ \t]+\\)[^ \t\n]")
-	  (progn
-	    (forward-word 2)
-	    (delete-horizontal-space)
-	    (insert (make-string cperl-indent-region-fix-constructs ?\ ))
-	    (beginning-of-line)))
-      ;; Looking at:
-      ;; foreach my $var     (
-      (if (looking-at
+	;; Looking at:
+	;; }
+	;; else
+	(if (and cperl-merge-trailing-else
+		 (looking-at
+		  "[ \t]*}[ \t]*\n[ \t\n]*\\(els\\(e\\|if\\)\\|continue\\)\\>"))
+	    (progn
+	      (search-forward "}")
+	      (setq p (point))
+	      (skip-chars-forward " \t\n")
+	      (delete-region p (point))
+	      (insert (make-string cperl-indent-region-fix-constructs ?\ ))
+	      (beginning-of-line)))
+	;; Looking at:
+	;; }     else
+	(if (looking-at "[ \t]*}\\(\t*\\|[ \t][ \t]+\\)\\<\\(els\\(e\\|if\\)\\|continue\\)\\>")
+	    (progn
+	      (search-forward "}")
+	      (delete-horizontal-space)
+	      (insert (make-string cperl-indent-region-fix-constructs ?\ ))
+	      (beginning-of-line)))
+	;; Looking at:
+	;; else   {
+	(if (looking-at
+	     "[ \t]*}?[ \t]*\\<\\(\\els\\(e\\|if\\)\\|continue\\|unless\\|if\\|while\\|for\\(each\\)?\\|until\\)\\>\\(\t*\\|[ \t][ \t]+\\)[^ \t\n#]")
+	    (progn
+	      (forward-word 1)
+	      (delete-horizontal-space)
+	      (insert (make-string cperl-indent-region-fix-constructs ?\ ))
+	      (beginning-of-line)))
+	;; Looking at:
+	;; foreach my    $var
+	(if (looking-at
+	     "[ \t]*\\<for\\(each\\)?[ \t]+\\(my\\|local\\|our\\)\\(\t*\\|[ \t][ \t]+\\)[^ \t\n]")
+	    (progn
+	      (forward-word 2)
+	      (delete-horizontal-space)
+	      (insert (make-string cperl-indent-region-fix-constructs ?\ ))
+	      (beginning-of-line)))
+	;; Looking at:
+	;; foreach my $var     (
+	(if (looking-at
 	     "[ \t]*\\<for\\(each\\)?[ \t]+\\(my\\|local\\|our\\)[ \t]*\\$[_a-zA-Z0-9]+\\(\t*\\|[ \t][ \t]+\\)[^ \t\n#]")
-	  (progn
-	    (forward-word 3)
-	    (delete-horizontal-space)
-	    (insert
-	     (make-string cperl-indent-region-fix-constructs ?\ ))
-	    (beginning-of-line)))
-      ;; Looking at:
-      ;; } foreach my $var ()    {
-      (if (looking-at
+	    (progn
+	      (forward-word 3)
+	      (delete-horizontal-space)
+	      (insert
+	       (make-string cperl-indent-region-fix-constructs ?\ ))
+	      (beginning-of-line)))
+	;; Looking at:
+	;; } foreach my $var ()    {
+	(if (looking-at
 	     "[ \t]*\\(}[ \t]*\\)?\\<\\(\\els\\(e\\|if\\)\\|continue\\|if\\|unless\\|while\\|for\\(each\\)?\\(\\([ \t]+\\(my\\|local\\|our\\)\\)?[ \t]*\\$[_a-zA-Z0-9]+\\)?\\|until\\)\\>\\([ \t]*(\\|[ \t\n]*{\\)\\|[ \t]*{")
-	  (progn
-	    (setq ml (match-beginning 8))
-	    (re-search-forward "[({]")
-	    (forward-char -1)
-	    (setq p (point))
-	    (if (eq (following-char) ?\( )
-		(progn
-		  (forward-sexp 1)
-		  (setq pp (point)))
-	      ;; after `else' or nothing
-	      (if ml	; after `else'
-		  (skip-chars-backward " \t\n")
-		(beginning-of-line))
-	      (setq pp nil))
-	    ;; Now after the sexp before the brace
-	    ;; Multiline expr should be special
-	    (setq ml (and pp (save-excursion (goto-char p)
-					     (search-forward "\n" pp t))))
-	    (if (and (or (not pp) (< pp end))
-		     (looking-at "[ \t\n]*{"))
-		(progn
-		  (cond
-		   ((bolp)		; Were before `{', no if/else/etc
-		    nil)
-		   ((looking-at "\\(\t*\\| [ \t]+\\){")
-		    (delete-horizontal-space)
-		    (if (if ml
-			    cperl-extra-newline-before-brace-multiline
-			  cperl-extra-newline-before-brace)
-			(progn
-			  (delete-horizontal-space)
-			  (insert "\n")
-			  (setq ret (point))
-			  (if (cperl-indent-line parse-data)
-			      (progn
-				(cperl-fix-line-spacing end parse-data)
-				(setq ret (point)))))
+	    (progn
+	      (setq ml (match-beginning 8))
+	      (re-search-forward "[({]")
+	      (forward-char -1)
+	      (setq p (point))
+	      (if (eq (following-char) ?\( )
+		  (progn
+		    (forward-sexp 1)
+		    (setq pp (point)))
+		;; after `else' or nothing
+		(if ml			; after `else'
+		    (skip-chars-backward " \t\n")
+		  (beginning-of-line))
+		(setq pp nil))
+	      ;; Now after the sexp before the brace
+	      ;; Multiline expr should be special
+	      (setq ml (and pp (save-excursion (goto-char p)
+					       (search-forward "\n" pp t))))
+	      (if (and (or (not pp) (< pp end))
+		       (looking-at "[ \t\n]*{"))
+		  (progn
+		    (cond
+		     ((bolp)		; Were before `{', no if/else/etc
+		      nil)
+		     ((looking-at "\\(\t*\\| [ \t]+\\){")
+		      (delete-horizontal-space)
+		      (if (if ml
+			      cperl-extra-newline-before-brace-multiline
+			    cperl-extra-newline-before-brace)
+			  (progn
+			    (delete-horizontal-space)
+			    (insert "\n")
+			    (setq ret (point))
+			    (if (cperl-indent-line parse-data)
+				(progn
+				  (cperl-fix-line-spacing end parse-data)
+				  (setq ret (point)))))
+			(insert
+			 (make-string cperl-indent-region-fix-constructs ?\ ))))
+		     ((and (looking-at "[ \t]*\n")
+			   (not (if ml
+				    cperl-extra-newline-before-brace-multiline
+				  cperl-extra-newline-before-brace)))
+		      (setq pp (point))
+		      (skip-chars-forward " \t\n")
+		      (delete-region pp (point))
 		      (insert
 		       (make-string cperl-indent-region-fix-constructs ?\ ))))
-		   ((and (looking-at "[ \t]*\n")
-			 (not (if ml
-				  cperl-extra-newline-before-brace-multiline
-				cperl-extra-newline-before-brace)))
-		    (setq pp (point))
-		    (skip-chars-forward " \t\n")
-		    (delete-region pp (point))
-		    (insert
-		     (make-string cperl-indent-region-fix-constructs ?\ ))))
-		  ;; Now we are before `{'
-		  (if (looking-at "[ \t\n]*{[ \t]*[^ \t\n#]")
-		      (progn
-			(skip-chars-forward " \t\n")
-			(setq pp (point))
-			(forward-sexp 1)
-			(setq p (point))
-			(goto-char pp)
-			(setq ml (search-forward "\n" p t))
-			(if (or cperl-break-one-line-blocks-when-indent ml)
-			    ;; not good: multi-line BLOCK
-			    (progn
-			      (goto-char (1+ pp))
-			      (delete-horizontal-space)
-			      (insert "\n")
-			      (setq ret (point))
-			      (if (cperl-indent-line parse-data)
-				  (setq ret (cperl-fix-line-spacing end parse-data)))))))))))
-      (beginning-of-line)
-      (setq p (point) pp (save-excursion (end-of-line) (point))) ; May be different from ee.
-      ;; Now check whether there is a hanging `}'
-      ;; Looking at:
-      ;; } blah
-      (if (and
-	   cperl-fix-hanging-brace-when-indent
-	   have-brace
-	   (not (looking-at "[ \t]*}[ \t]*\\(\\<\\(els\\(if\\|e\\)\\|continue\\|while\\|until\\)\\>\\|$\\|#\\)"))
-	   (condition-case nil
-	       (progn
-		 (up-list 1)
-		 (if (and (<= (point) pp)
-			  (eq (preceding-char) ?\} )
-			  (cperl-after-block-and-statement-beg (point-min)))
-		     t
-		   (goto-char p)
-		   nil))
-	     (error nil)))
-	  (progn
-	    (forward-char -1)
-	    (skip-chars-backward " \t")
-	    (if (bolp)
-		;; `}' was the first thing on the line, insert NL *after* it.
-		(progn
-		  (cperl-indent-line parse-data)
-		  (search-forward "}")
-		  (delete-horizontal-space)
-		  (insert "\n"))
-	      (delete-horizontal-space)
-	      (or (eq (preceding-char) ?\;)
-		  (bolp)
-		  (and (eq (preceding-char) ?\} )
-		       (cperl-after-block-p (point-min)))
-		  (insert ";"))
-	      (insert "\n")
-	      (setq ret (point)))
-	    (if (cperl-indent-line parse-data)
-		(setq ret (cperl-fix-line-spacing end parse-data)))
-	    (beginning-of-line)))))
+		    ;; Now we are before `{'
+		    (if (looking-at "[ \t\n]*{[ \t]*[^ \t\n#]")
+			(progn
+			  (skip-chars-forward " \t\n")
+			  (setq pp (point))
+			  (forward-sexp 1)
+			  (setq p (point))
+			  (goto-char pp)
+			  (setq ml (search-forward "\n" p t))
+			  (if (or cperl-break-one-line-blocks-when-indent ml)
+			      ;; not good: multi-line BLOCK
+			      (progn
+				(goto-char (1+ pp))
+				(delete-horizontal-space)
+				(insert "\n")
+				(setq ret (point))
+				(if (cperl-indent-line parse-data)
+				    (setq ret (cperl-fix-line-spacing end parse-data)))))))))))
+	(beginning-of-line)
+	(setq p (point) pp (save-excursion (end-of-line) (point))) ; May be different from ee.
+	;; Now check whether there is a hanging `}'
+	;; Looking at:
+	;; } blah
+	(if (and
+	     cperl-fix-hanging-brace-when-indent
+	     have-brace
+	     (not (looking-at "[ \t]*}[ \t]*\\(\\<\\(els\\(if\\|e\\)\\|continue\\|while\\|until\\)\\>\\|$\\|#\\)"))
+	     (condition-case nil
+		 (progn
+		   (up-list 1)
+		   (if (and (<= (point) pp)
+			    (eq (preceding-char) ?\} )
+			    (cperl-after-block-and-statement-beg (point-min)))
+		       t
+		     (goto-char p)
+		     nil))
+	       (error nil)))
+	    (progn
+	      (forward-char -1)
+	      (skip-chars-backward " \t")
+	      (if (bolp)
+		  ;; `}' was the first thing on the line, insert NL *after* it.
+		  (progn
+		    (cperl-indent-line parse-data)
+		    (search-forward "}")
+		    (delete-horizontal-space)
+		    (insert "\n"))
+		(delete-horizontal-space)
+		(or (eq (preceding-char) ?\;)
+		    (bolp)
+		    (and (eq (preceding-char) ?\} )
+			 (cperl-after-block-p (point-min)))
+		    (insert ";"))
+		(insert "\n")
+		(setq ret (point)))
+	      (if (cperl-indent-line parse-data)
+		  (setq ret (cperl-fix-line-spacing end parse-data)))
+	      (beginning-of-line)))))
     ret))
 
 (defvar cperl-update-start)		; Do not need to make them local
@@ -4067,76 +4048,75 @@
   (cperl-update-syntaxification end end)
   (save-excursion
     (let (cperl-update-start cperl-update-end (h-a-c after-change-functions))
-      (let (st comm old-comm-indent new-comm-indent p pp i empty
-	       (indent-info (if cperl-emacs-can-parse
-				(list nil nil nil) ; Cannot use '(), since will modify
-			      nil))
-	       after-change-functions	; Speed it up!
-	     (pm 0) (imenu-scanning-message "Indenting... (%3d%%)"))
+      (let ((indent-info (if cperl-emacs-can-parse
+			     (list nil nil nil)	; Cannot use '(), since will modify
+			   nil))
+	    (pm 0) (imenu-scanning-message "Indenting... (%3d%%)")
+	    after-change-functions	; Speed it up!
+	    st comm old-comm-indent new-comm-indent p pp i empty)
 	(if h-a-c (add-hook 'after-change-functions 'cperl-delay-update-hook))
-      (goto-char start)
-      (setq old-comm-indent (and (cperl-to-comment-or-eol)
-				 (current-column))
-	    new-comm-indent old-comm-indent)
-      (goto-char start)
-      (setq end (set-marker (make-marker) end))	; indentation changes pos
-      (or (bolp) (beginning-of-line 2))
-      (or (fboundp 'imenu-progress-message)
-	  (message "Indenting... For feedback load `imenu'..."))
-      (while (and (<= (point) end) (not (eobp))) ; bol to check start
-	(and (fboundp 'imenu-progress-message)
-	     (imenu-progress-message
-	      pm (/ (* 100 (- (point) start)) (- end start -1))))
+	(goto-char start)
+	(setq old-comm-indent (and (cperl-to-comment-or-eol)
+				   (current-column))
+	      new-comm-indent old-comm-indent)
+	(goto-char start)
+	(setq end (set-marker (make-marker) end)) ; indentation changes pos
+	(or (bolp) (beginning-of-line 2))
+	(or (fboundp 'imenu-progress-message)
+	    (message "Indenting... For feedback load `imenu'..."))
+	(while (and (<= (point) end) (not (eobp))) ; bol to check start
+	  (and (fboundp 'imenu-progress-message)
+	       (imenu-progress-message
+		pm (/ (* 100 (- (point) start)) (- end start -1))))
 	  (setq st (point))
 	  (if (or
 	       (setq empty (looking-at "[ \t]*\n"))
 	       (and (setq comm (looking-at "[ \t]*#"))
-		 (or (eq (current-indentation) (or old-comm-indent
-						   comment-column))
+		    (or (eq (current-indentation) (or old-comm-indent
+						      comment-column))
 			(setq old-comm-indent nil))))
-	    (if (and old-comm-indent
+	      (if (and old-comm-indent
 		       (not empty)
-		     (= (current-indentation) old-comm-indent)
+		       (= (current-indentation) old-comm-indent)
 		       (not (eq (get-text-property (point) 'syntax-type) 'pod))
 		       (not (eq (get-text-property (point) 'syntax-table)
 				cperl-st-cfence)))
-		(let ((comment-column new-comm-indent))
-		  (indent-for-comment)))
-	  (progn
+		  (let ((comment-column new-comm-indent))
+		    (indent-for-comment)))
+	    (progn
 	      (setq i (cperl-indent-line indent-info))
-	    (or comm
-		(not i)
-		(progn
-		  (if cperl-indent-region-fix-constructs
+	      (or comm
+		  (not i)
+		  (progn
+		    (if cperl-indent-region-fix-constructs
 			(goto-char (cperl-fix-line-spacing end indent-info)))
-		  (if (setq old-comm-indent
-			    (and (cperl-to-comment-or-eol)
-				 (not (memq (get-text-property (point)
-							       'syntax-type)
-					    '(pod here-doc)))
+		    (if (setq old-comm-indent
+			      (and (cperl-to-comment-or-eol)
+				   (not (memq (get-text-property (point)
+								 'syntax-type)
+					      '(pod here-doc)))
 				   (not (eq (get-text-property (point)
 							       'syntax-table)
 					    cperl-st-cfence))
-				 (current-column)))
-		      (progn (indent-for-comment)
-			     (skip-chars-backward " \t")
-			     (skip-chars-backward "#")
-			     (setq new-comm-indent (current-column))))))))
-	(beginning-of-line 2))
+				   (current-column)))
+			(progn (indent-for-comment)
+			       (skip-chars-backward " \t")
+			       (skip-chars-backward "#")
+			       (setq new-comm-indent (current-column))))))))
+	  (beginning-of-line 2))
       	(if (fboundp 'imenu-progress-message)
-	     (imenu-progress-message pm 100)
+	    (imenu-progress-message pm 100)
 	  (message nil)))
       ;; Now run the update hooks
-      (if after-change-functions
-	  (save-excursion
-	    (if cperl-update-end
-		(progn
-		  (goto-char cperl-update-end)
-		  (insert " ")
-		  (delete-char -1)
-		  (goto-char cperl-update-start)
-		  (insert " ")
-		  (delete-char -1))))))))
+      (and after-change-functions
+	   cperl-update-end
+	   (progn
+	     (goto-char cperl-update-end)
+	     (insert " ")
+	     (delete-char -1)
+	     (goto-char cperl-update-start)
+	     (insert " ")
+	     (delete-char -1))))))
 
 ;; Stolen from lisp-mode with a lot of improvements
 
@@ -4146,8 +4126,7 @@
 block of it that point is in, preserving the comment's initial
 indentation and initial hashes.  Behaves usually outside of comment."
   (interactive "P")
-  (let (
-	;; Non-nil if the current line contains a comment.
+  (let (;; Non-nil if the current line contains a comment.
 	has-comment
 
 	;; If has-comment, the appropriate fill-prefix for the comment.
@@ -4183,7 +4162,7 @@
 	(delete-char len)
 	(insert (make-string dc ?-)))))
     (if (not has-comment)
-	(fill-paragraph justify)	; Do the usual thing outside of comment
+	(fill-paragraph justify)       ; Do the usual thing outside of comment
       ;; Narrow to include only the comment, and then fill the region.
       (save-restriction
 	(narrow-to-region
@@ -4217,7 +4196,7 @@
 	  (progn
 	    (goto-char start)
 	    (if (> dc 0)
-	      (progn (delete-char dc) (insert spaces)))
+		(progn (delete-char dc) (insert spaces)))
 	    (if (or (= (current-column) c) iteration) nil
 	      (setq comment-column c)
 	      (indent-for-comment)
@@ -4230,22 +4209,22 @@
 	   (end-of-line)
 	   (current-column))
 	 fill-column)
-  (let ((c (save-excursion (beginning-of-line)
-			   (cperl-to-comment-or-eol) (point)))
-	(s (memq (following-char) '(?\ ?\t))) marker)
-    (if (>= c (point)) nil
-      (setq marker (point-marker))
-      (cperl-fill-paragraph)
-      (goto-char marker)
-      ;; Is not enough, sometimes marker is a start of line
-      (if (bolp) (progn (re-search-forward "#+[ \t]*")
-			(goto-char (match-end 0))))
-      ;; Following space could have gone:
-      (if (or (not s) (memq (following-char) '(?\ ?\t))) nil
-	(insert " ")
-	(backward-char 1))
-      ;; Previous space could have gone:
-      (or (memq (preceding-char) '(?\ ?\t)) (insert " "))))))
+      (let ((c (save-excursion (beginning-of-line)
+			       (cperl-to-comment-or-eol) (point)))
+	    (s (memq (following-char) '(?\ ?\t))) marker)
+	(if (>= c (point)) nil
+	  (setq marker (point-marker))
+	  (cperl-fill-paragraph)
+	  (goto-char marker)
+	  ;; Is not enough, sometimes marker is a start of line
+	  (if (bolp) (progn (re-search-forward "#+[ \t]*")
+			    (goto-char (match-end 0))))
+	  ;; Following space could have gone:
+	  (if (or (not s) (memq (following-char) '(?\ ?\t))) nil
+	    (insert " ")
+	    (backward-char 1))
+	  ;; Previous space could have gone:
+	  (or (memq (preceding-char) '(?\ ?\t)) (insert " "))))))
 
 (defun cperl-imenu-addback (lst &optional isback name)
   ;; We suppose that the lst is a DAG, unless the first element only
@@ -4255,15 +4234,14 @@
 	(t
 	 (or name
 	     (setq name "+++BACK+++"))
-	 (mapcar (function (lambda (elt)
-			     (if (and (listp elt) (listp (cdr elt)))
-				 (progn
-				   ;; In the other order it goes up
-				   ;; one level only ;-(
-				   (setcdr elt (cons (cons name lst)
-						     (cdr elt)))
-				   (cperl-imenu-addback (cdr elt) t name)
-				   ))))
+	 (mapcar (lambda (elt)
+		   (if (and (listp elt) (listp (cdr elt)))
+		       (progn
+			 ;; In the other order it goes up
+			 ;; one level only ;-(
+			 (setcdr elt (cons (cons name lst)
+					   (cdr elt)))
+			 (cperl-imenu-addback (cdr elt) t name))))
 		 (if isback (cdr lst) lst))
 	 lst)))
 
@@ -4291,7 +4269,7 @@
 	   (match-beginning 2)		; package or sub
 	   (eq (char-after (match-beginning 2)) ?p) ; package
 	   (not (save-match-data
-		  (looking-at "[ \t\n]*;"))))  ; Plain text word 'package'
+		  (looking-at "[ \t\n]*;")))) ; Plain text word 'package'
 	  nil)
 	 ((and
 	   (match-beginning 2)		; package or sub
@@ -4301,8 +4279,7 @@
 	   (null (get-text-property (match-beginning 1) 'in-pod)))
 	  (save-excursion
 	    (goto-char (match-beginning 2))
-	    (setq fchar (following-char))
-	    )
+	    (setq fchar (following-char)))
 	  ;; (if (looking-at "([^()]*)[ \t\n\f]*")
 	  ;;    (goto-char (match-end 0)))	; Messes what follows
 	  (setq char (following-char)	; ?\; for "sub foo () ;"
@@ -4345,7 +4322,7 @@
 	      (push index index-alist))
 	    (if meth (push index index-meth-alist))
 	    (push index index-unsorted-alist)))
-	 ((match-beginning 5)		; Pod section
+	 ((match-beginning 5)		; POD section
 	  ;; (beginning-of-line)
 	  (setq index (imenu-example--name-and-position)
 		name (buffer-substring (match-beginning 6) (match-end 6)))
@@ -4361,7 +4338,7 @@
     (setq index-alist
 	  (if (default-value 'imenu-sort-function)
 	      (sort index-alist (default-value 'imenu-sort-function))
-	      (nreverse index-alist)))
+	    (nreverse index-alist)))
     (and index-pod-alist
 	 (push (cons "+POD headers+..."
 		     (nreverse index-pod-alist))
